CREATE OR REPLACE VIEW RECHERCHE.NOMENCLATURE_GENERIQUE AS
  SELECT NM.STR_ID AS ID, CODE, NVL(NOB.LIBELLE_COURT_CUSTOM, NOB.LIBELLE_COURT) AS LIBELLE_COURT, NVL(NOB.LIBELLE_LONG_CUSTOM, NOB.LIBELLE_LONG) AS LIBELLE_LONG
    FROM RECHERCHE.NOMENCLATURE_NOMENCLATURES NM
      INNER JOIN RECHERCHE.NOMENCLATURE_OBJETS NOB ON NM.ID = NOB.NOMENCLATURE_ID;

CREATE OR REPLACE VIEW RECHERCHE.SUIVI_ADMINISTRATIF_CONTRAT AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.contrats.suiviadministratifcontrat';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_REDACTION_CONTRAT AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.contrats.typeredactioncontrat';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_REDACTION_CLAUSESPI AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.contrats.typeredactionclausespi';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_APPORTS_DRVCONTRAT AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.contrats.typeapportsdrvcontrat';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_APPORTS_DAJCONTRAT AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.contrats.typeapportsdajcontrat';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_PROPRIETE_RESULTATS AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.contrats.typeproprieteresultats';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_EXPLOITATION_RESULTATS AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.contrats.typeexploitationresultats';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_GESTIONRESULTATS AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.contrats.typegestionresultats';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_SUIVIVALORISATION AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.contrats.typesuivivalorisation';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_FINANCEMENTS AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.aap.typefinancements';

CREATE OR REPLACE VIEW RECHERCHE.MOYEN_DEPOTDOSSIER AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.aap.moyendepotdossier';

CREATE OR REPLACE VIEW RECHERCHE.ETAT_ACCEPTATIONREFUS AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.aap.etatacceptationrefus';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_SUIVIVALORISATION AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.aap.typesuivivalorisation';

CREATE OR REPLACE VIEW RECHERCHE.MOYEN_ENVOIDOSSIERS AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.aap.moyenenvoidossiers';

CREATE OR REPLACE VIEW RECHERCHE.TYPE_ETATMONTAGE AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.aap.typeetatmontage';

CREATE OR REPLACE VIEW RECHERCHE.LISTE_AVIS AS
  SELECT * FROM RECHERCHE.NOMENCLATURE_GENERIQUE
    WHERE ID = 'org.cocktail.fwkcktlsangria.aap.listeavis';

GRANT SELECT ON GRHUM.PERSONNE TO RECHERCHE;

-- ajout SB
grant select on accords.contrat_partenaire to recherche;
-- /ajout SB

CREATE OR REPLACE FUNCTION RECHERCHE.LISTE_PARTENAIRES(CON_ORDRE IN NUMBER) RETURN VARCHAR2 IS
  CURSOR PARTENAIRES(conOrdre NUMBER) IS
    SELECT P.LIBELLE AS LIBELLE FROM ACCORDS.CONTRAT C
      INNER JOIN ACCORDS.CONTRAT_PARTENAIRE CP ON C.CON_ORDRE = CP.CON_ORDRE
        INNER JOIN
          (SELECT PERS_ID, LL_STRUCTURE || NVL2(LC_STRUCTURE, '(' || LC_STRUCTURE || ')', '') AS LIBELLE FROM GRHUM.STRUCTURE_ULR UNION SELECT PERS_ID, NOM_USUEL || ' ' || PRENOM AS LIBELLE FROM GRHUM.INDIVIDU_ULR)  P ON P.PERS_ID = CP.PERS_ID
          WHERE C.CON_ORDRE = conOrdre
            AND CP.PERS_ID NOT IN (
              SELECT S.PERS_ID FROM GRHUM.STRUCTURE_ULR S
                INNER JOIN GRHUM.REPART_TYPE_GROUPE RTG ON RTG.C_STRUCTURE = S.C_STRUCTURE
                  WHERE TGRP_CODE = 'SR');
  resultat VARCHAR2(4000);
  i NUMBER;
BEGIN
  resultat := '';
  i := 1;
  FOR p in PARTENAIRES(CON_ORDRE) LOOP
    IF i <> 1 THEN
      resultat := resultat || '/';
    END IF;
    i := i + 1;
    resultat := resultat ||  p.libelle;
  END LOOP;
  return resultat;
END;
/

CREATE OR REPLACE FUNCTION RECHERCHE.LISTE_LABOS(CON_ORDRE IN NUMBER) RETURN VARCHAR2 IS
  CURSOR PARTENAIRES(conOrdre NUMBER) IS
    SELECT S.LC_STRUCTURE AS LIBELLE FROM ACCORDS.CONTRAT C
      INNER JOIN ACCORDS.CONTRAT_PARTENAIRE CP ON C.CON_ORDRE = CP.CON_ORDRE
        INNER JOIN GRHUM.STRUCTURE_ULR S ON S.PERS_ID = CP.PERS_ID
          WHERE C.CON_ORDRE = conOrdre
            AND CP.PERS_ID IN (
              SELECT S.PERS_ID FROM GRHUM.STRUCTURE_ULR S
                INNER JOIN GRHUM.REPART_TYPE_GROUPE RTG ON RTG.C_STRUCTURE = S.C_STRUCTURE
                  WHERE TGRP_CODE = 'SR');
  resultat VARCHAR2(4000);
  i NUMBER;
BEGIN
  resultat := '';
  i := 1;
  FOR p in PARTENAIRES(CON_ORDRE) LOOP
    IF i <> 1 THEN
      resultat := resultat || '/';
    END IF;
    i := i + 1;
    resultat := resultat ||  p.libelle;
  END LOOP;
  return resultat;
END;
/

-- ajout SB
grant select on accords.contrat_part_contact to recherche;
-- /ajout SB

CREATE OR REPLACE FUNCTION RECHERCHE.LISTE_RESP_SCIENT(CON_ORDRE IN NUMBER) RETURN VARCHAR2 IS
  CURSOR RESPOS(conOrdre NUMBER) IS
    SELECT P.PERS_LIBELLE || NVL2(P.PERS_LC, ' ' || P.PERS_LC, '') AS LIBELLE FROM ACCORDS.CONTRAT C
      INNER JOIN ACCORDS.CONTRAT_PARTENAIRE CP ON C.CON_ORDRE = CP.CON_ORDRE
        INNER JOIN ACCORDS.CONTRAT_PART_CONTACT CPC ON CPC.CP_ORDRE = CP.CP_ORDRE
          INNER JOIN GRHUM.PERSONNE P ON P.PERS_ID = CPC.PERS_ID_CONTACT
            WHERE C.CON_ORDRE = conOrdre
              AND CP.PERS_ID IN (
                SELECT S.PERS_ID FROM GRHUM.STRUCTURE_ULR S
                  INNER JOIN GRHUM.REPART_TYPE_GROUPE RTG ON RTG.C_STRUCTURE = S.C_STRUCTURE
                    WHERE TGRP_CODE = 'SR');
  resultat VARCHAR2(4000);
  i NUMBER;
BEGIN
  resultat := '';
  i := 1;
  FOR r in RESPOS(CON_ORDRE) LOOP
    IF i <> 1 THEN
      resultat := resultat || '/';
    END IF;
    i := i + 1;
    resultat := resultat ||  r.libelle;
  END LOOP;
  return resultat;
END;
/

CREATE OR REPLACE VIEW RECHERCHE.CONTRAT_PERSONNE_ROLE AS
  SELECT CON_ORDRE, P.PERS_LIBELLE || NVL2(P.PERS_LC, ' ' || P.PERS_LC, '') AS PERS_LIBELLE, A.ASS_CODE FROM ACCORDS.CONTRAT C
    INNER JOIN GRHUM.REPART_ASSOCIATION RA ON C.CON_GROUPE_PARTENAIRE = RA.C_STRUCTURE
      INNER JOIN GRHUM.ASSOCIATION A ON A.ASS_ID = RA.ASS_ID
        INNER JOIN GRHUM.PERSONNE P ON P.PERS_ID = RA.PERS_ID;


GRANT SELECT ON GRHUM.EVT_EVENEMENT TO RECHERCHE;
GRANT SELECT ON GRHUM.EVT_EVENEMENT_TYPE TO RECHERCHE;
GRANT SELECT ON ACCORDS.AVENANT_EVT_EVENEMENT TO RECHERCHE;

CREATE OR REPLACE VIEW RECHERCHE.CONTRAT_NOTES AS
  SELECT C.CON_ORDRE, EVT_OBJET AS LIBELLE, E.EVT_DATE_PREVUE DATE_PREVUE FROM ACCORDS.CONTRAT C
    INNER JOIN ACCORDS.AVENANT A ON A.CON_ORDRE = C.CON_ORDRE
      INNER JOIN ACCORDS.AVENANT_EVT_EVENEMENT AEE ON A.AVT_ORDRE = AEE.AVT_ORDRE
        INNER JOIN GRHUM.EVT_EVENEMENT E ON AEE.EVT_ID = E.EVT_ID
          INNER JOIN GRHUM.EVT_EVENEMENT_TYPE ET ON E.EVTT_ID = ET.EVTT_ID
            WHERE ET.EVTT_ID_INTERNE = 'NOTE'
              ORDER BY E.EVT_DATE_PREVUE DESC;


CREATE OR REPLACE VIEW RECHERCHE.EXPORT_AAPS AS
  SELECT
    A.AAP_ORDRE,
    C.CON_ORDRE,
    C.EXE_ORDRE || '-' || TRIM(TO_CHAR(C.CON_INDEX, '0000')) AS NUMERO,
    C.CON_OBJET AS LIBELLE_LONG,
    C.CON_OBJET_COURT AS LIBELLE_COURT,
    (SELECT PERS_LIBELLE FROM RECHERCHE.CONTRAT_PERSONNE_ROLE WHERE CON_ORDRE = C.CON_ORDRE AND ASS_CODE = 'FINANCEUR') AS FINANCEUR,
    (SELECT LL_PROGRAMME FROM RECHERCHE.PROGRAMMES WHERE ID = A.APP_PROG_ID) AS PROGRAMME,
    (SELECT LL_PROGRAMME FROM RECHERCHE.PROGRAMMES WHERE ID = A.APP_SS_PROG_ID) AS SOUS_PROGRAMME,
    (SELECT PERS_LIBELLE FROM RECHERCHE.CONTRAT_PERSONNE_ROLE WHERE CON_ORDRE = C.CON_ORDRE AND ASS_CODE = 'COORDINATIOI') AS COORDINATION_INTERNE,
    (SELECT PERS_LIBELLE FROM RECHERCHE.CONTRAT_PERSONNE_ROLE WHERE CON_ORDRE = C.CON_ORDRE AND ASS_CODE = 'COORDINTERNE') AS COORDINATEUR_INTERNE,
    (SELECT PERS_LIBELLE FROM RECHERCHE.CONTRAT_PERSONNE_ROLE WHERE CON_ORDRE = C.CON_ORDRE AND ASS_CODE = 'COORDINATIOE') AS COORDINATION_EXTERNE,
    (SELECT PERS_LIBELLE FROM RECHERCHE.CONTRAT_PERSONNE_ROLE WHERE CON_ORDRE = C.CON_ORDRE AND ASS_CODE = 'COORDEXTERNE') AS COORDINATEUR_EXTERNE,
    RECHERCHE.LISTE_LABOS(C.CON_ORDRE) AS LABORATOIRES,
    RECHERCHE.LISTE_PARTENAIRES(C.CON_ORDRE) AS PARTENAIRES,
    RECHERCHE.LISTE_RESP_SCIENT(C.CON_ORDRE) AS RESPONSABLES_SCIENCTIFIQUES,
    AVT.AVT_MONTANT_GLOBAL AS MONTANT_GLOBAL,
    (SELECT SUM(MONTANT_OBTENU) FROM RECHERCHE.REPART_TYPE_FINANC_AAP WHERE AAP_ORDRE = A.AAP_ORDRE) AS TOTAL_OBTENU,
    TO_CHAR(A.DATE_PASSAGE_CS, 'DD/MM/YY') AS DATE_PASSAGE_CS,
    (SELECT LIBELLE_LONG FROM RECHERCHE.LISTE_AVIS WHERE CODE = A.AVIS_PASSAGE_CS) AS AVIS_CS,
    CLASSEMENT_PASSAGE_CS,
    (SELECT LIBELLE_LONG FROM RECHERCHE.ETAT_ACCEPTATIONREFUS WHERE CODE = A.ETAT_ACCEPT) AS ETAT,
    (SELECT LIBELLE FROM RECHERCHE.CONTRAT_NOTES WHERE CON_ORDRE = C.CON_ORDRE AND ROWNUM = 1) AS OBSERVATIONS
    FROM RECHERCHE.AAP A
      INNER JOIN ACCORDS.CONTRAT C ON A.CON_ORDRE = C.CON_ORDRE and A.AAP_SUPPR = 0
        INNER JOIN ACCORDS.AVENANT AVT ON AVT.CON_ORDRE = C.CON_ORDRE AND AVT.AVT_INDEX = 0;




grant select on accords.type_contrat to recherche;
grant select on accords.MODE_GESTION to recherche;


CREATE OR REPLACE VIEW RECHERCHE.EXPORT_CONTRATS AS
SELECT
    CR.CONR_ORDRE,
    C.CON_ORDRE,
    C.EXE_ORDRE || '-' || TRIM(TO_CHAR(C.CON_INDEX, '0000')) AS NUMERO,
    C.CON_OBJET AS LIBELLE_LONG,
    C.CON_OBJET_COURT AS LIBELLE_COURT,
    case when MG.MG_LIBELLE_COURT = 'SIF' then null else (SELECT TYCON_LIBELLE FROM ACCORDS.TYPE_CONTRAT WHERE TYCON_ID = C.CON_NATURE) end AS TYPE_DE_CONTRAT,
    (SELECT LC_STRUCTURE FROM GRHUM.STRUCTURE_ULR WHERE C_STRUCTURE = C.CON_ETABLISSEMENT) AS ETABLISSEMENT_GESTIONNAIRE,
    (SELECT PERS_LIBELLE FROM RECHERCHE.CONTRAT_PERSONNE_ROLE WHERE CON_ORDRE = C.CON_ORDRE AND ASS_CODE = 'VALIDVALO') AS VALIDATEUR_VALO,
    (SELECT PERS_LIBELLE FROM RECHERCHE.CONTRAT_PERSONNE_ROLE WHERE CON_ORDRE = C.CON_ORDRE AND ASS_CODE = 'CREATDOSSIER') AS CREATEUR_DOSSIER,
    RECHERCHE.LISTE_LABOS(C.CON_ORDRE) AS LABORATOIRES,
    RECHERCHE.LISTE_PARTENAIRES(C.CON_ORDRE) AS PARTENAIRES,
    RECHERCHE.LISTE_RESP_SCIENT(C.CON_ORDRE) AS RESPONSABLES_SCIENTIFIQUES,
    case when MG.MG_LIBELLE_COURT = 'SIF' then null else AVT.AVT_MONTANT_HT end AS MONTANT_HT,
    case when MG.MG_LIBELLE_COURT = 'SIF' then 'OUI' else 'NON' end AS INCIDENCE_FINANCIERE,
    (SELECT LIBELLE_LONG FROM RECHERCHE.SUIVI_ADMINISTRATIF_CONTRAT WHERE CODE = CR.SUIVI_ADMIN) AS ETAT,
    (SELECT LIBELLE FROM RECHERCHE.CONTRAT_NOTES WHERE CON_ORDRE = C.CON_ORDRE AND ROWNUM = 1) AS OBSERVATIONS

    FROM RECHERCHE.CONTRAT_RECHERCHE CR
      INNER JOIN ACCORDS.CONTRAT C ON CR.CON_ORDRE = C.CON_ORDRE and CR.CR_SUPPR = 0
        INNER JOIN ACCORDS.AVENANT AVT ON AVT.CON_ORDRE = C.CON_ORDRE AND AVT.AVT_INDEX = 0
          LEFT OUTER JOIN ACCORDS.MODE_GESTION MG ON MG.MG_ORDRE = AVT.AVT_MODE_GEST;
